//  CAFE2011.EXE is licensed under the terms of the CC-LGPL.
//  (CC-LGPL Version 3, 29 junio 2007 y CAFE2011 version 2011)
//  El objetivo es el libre uso comercial y no comercial del software.
//  Una copia de dicho documento se incluye en esta distribucion.
//  CWSDPMI.EXE, STREAMCO.PAS, el procedimiento TextOut
//  se tomaron de la distribucion FreePascal 2.4.2. con patente similar.
//        StreamCo.PAS es una contraccion conveniente a ocho letras del
//        nombre StreamColl.PAS en la distribucion FreePascal
  {$MODE                OBJFPC          }
  {$INCLUDEPATH         ..\INCLUDE      }
  {$INCLUDE             CAFE_INC.INC    }
  {$DEFINE              SILENCIAR       }
unit CAFE_Ej2;

interface

uses CAFE_Ej1, SysUtils, Variants;

CONST
  CAFE_CharIgnoradoLibre                =
                CHR( 1+2+6+7+8+9+10+11+12*2+7*11+23 );
{
  CAFE_CharIgnoradoLibre                : Caracter agregado para la
        traduccion de operadores especiales. i.e: sustitucion de String.
        No deberian ser generados por el usuario.
}

  CAFE_CharImposible0                   = '';
{
  CAFE_CharImposible0                   : Caracter de sustitucion del
        cero cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible1                   = '';
{
  CAFE_CharImposible1                   : Caracter de sustitucion del
        uno cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible2                   = '';
{
  CAFE_CharImposible2                   : Caracter de sustitucion del
        dos cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible3                   = '';
{
  CAFE_CharImposible3                   : Caracter de sustitucion del
        tres cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible4                   = '';
{
  CAFE_CharImposible4                   : Caracter de sustitucion del
        cuatro cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible5                   = '';
{
  CAFE_CharImposible5                   : Caracter de sustitucion del
        cinco cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible6                   = '';
{
  CAFE_CharImposible6                   : Caracter de sustitucion del
        seis cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible7                   = '';
{
  CAFE_CharImposible7                   : Caracter de sustitucion del
        siete cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible8                   = '';
{
  CAFE_CharImposible8                   : Caracter de sustitucion del
        ocho cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_CharImposible9                   = '';
{
  CAFE_CharImposible9                   : Caracter de sustitucion del
        nueve cuando se requiera.  Debe ser imposible en la
        sintaxis de operadores final.  Aunque podria
        estar presente en comentarios y cadenas.
        Podria tener otros usos.
}

  CAFE_ByteIgnoradoLibre                = Ord( CAFE_CharIgnoradoLibre );
{
  CAFE_ByteIgnoradoLibre                : Version Byte de
        CAFE_CharIgnoradoLibre, probablemente mas facil de usar.
}

  CAFE_CharHojaCalculoFija              = '$';
{
  CAFE_CharHojaCalculoFija              : Char utilizado en hojas
        de calculo para direccionamiento absoluto.
}

  CAFE_ByteHojaCalculoFija              = Ord( CAFE_CharHojaCalculoFija );
{
  CAFE_ByteHojaCalculoFija              : Version Byte de
        CAFE_CharHojaCalculoFija para direccionamiento absoluto
}

CONST
  CAFE_ConjuntoCharNumeroArabigo        = [ '0'..'9' ];
{
  CAFE_ConjuntoCharNumeroArabigo        : Caracteres de numeros, para
        identificacion sintactica.
}

  CAFE_ConjuntoByteNumeroArabigo        = [ Ord( '0' )..Ord( '9' ) ];
{
  CAFE_ConjuntoByteNumeroArabigo        : Version Byte de
        CAFE_ConjuntoCharNumeroArabigo, para identificacion sintactica
        de numeros
}

  CAFE_ConjuntoCharLetrasBasicas        = [ 'A'..'Z' ];
{
  CAFE_ConjuntoCharLetrasBasicas        : Caracteres de letras mayusculas
        en la sintaxis pascal de Identificadores.
}
  CAFE_ConjuntoByteLetrasBasicas        = [ Ord( 'A' )..Ord( 'Z' ) ];
{
  CAFE_ConjuntoByteLetrasBasicas        : Version Byte de
        CAFE_ConjuntoCharLetrasBasicas, para operaciones Byte de
        letras en Identificadores pascal.
}

  CAFE_CharPositivoNumerico             = '+';
{
  CAFE_CharPositivoNumerico             : Char de signo positivo tradicional.
}

  CAFE_BytePositivoNumerico             = Ord( CAFE_CharPositivoNumerico );
{
  CAFE_BytePositivoNumerico             : Version Byte de
        CAFE_CharPositivoNumerico de signo positivo tradicional.
}

  CAFE_CharNegativoNumerico             = '-';
{
  CAFE_CharNegativoNumerico             : Char de signo negativo tradicional.
}

  CAFE_ByteNegativoNumerico             = Ord( CAFE_CharNegativoNumerico );
{
  CAFE_ByteNegativoNumerico             : Version Byte de
        CAFE_CharNegativoNumerico de signo negativo tradicional.
}

  CAFE_ConjuntoCharSignoNumerico        =
                [ CAFE_CharPositivoNumerico, CAFE_CharNegativoNumerico ];
{
  CAFE_ConjuntoCharSignoNumerico        : Conjunto de Char de
        signos admisibles numeracion.
}

  CAFE_ConjuntoByteSignoNumerico        =
                [ CAFE_BytePositivoNumerico, CAFE_ByteNegativoNumerico ];
{
  CAFE_ConjuntoByteSignoNumerico        : version Byte de
        CAFE_ConjuntoCharSignoNumerico admisibles en numeracion.
}

  CAFE_OperadorParentesisTraducidoOperadorBasico             =
                                        CAFE_CharIgnoradoLibre+'PP()';
{
  CAFE_OperadorParentesisTraducidoOperadorBasico        :
        Cadena para convertir el parentesis ordinario redondo,
        en operador basico, cuando se requiera.
}

VAR
  CAFE_ByteBlancoSintactico,
{
  CAFE_ByteBlancoSintactico             : Byte que se utilizara como
        blanco principal en la gramatica de operadores
}

  CAFE_ByteParentesisAbrirSintactico,
{
  CAFE_ByteParentesisAbrirSintactico    : Byte que representa el
        parentesis abierto en la gramatica de operadores
}

  CAFE_ByteParentesisCerrarSintactico,
{
  CAFE_ByteParentesisCerrarSintactico   : Byte que representa el
        parentesis cerrado en la gramatica de operadores
}

  CAFE_ByteSeparadorSintactico,
{
  CAFE_ByteSeparadorSintactico          : Byte que representa la coma
        o el separador que se utilice en parametros para la
        gramatica de operadores
}

  CAFE_ByteDecimalSintactico,
{
  CAFE_ByteDecimalSintactico            : Byte para el punto decimal
        o el byte que se utilice con ese fin.
}

  CAFE_ByteExponenteSintactico,
{
  CAFE_ByteExponenteSintactico          : Byte para el simbolo de
        esponencial de notacion cientifica. i.e. 2.3E-4.  La letra
        'E' es generalmente la utilizada.
}

  CAFE_ByteSeparadorOrdenSintactico,
{
  CAFE_ByteSeparadorOrdenSintactico     : Byte utilizado para la
        separacion de ordenes o frases sintactica.  En pascal se
        utiliza el punto y coma.
}

  CAFE_ByteDelimitadorStringSintactico,
{
  CAFE_ByteDelimitadorStringSintactico  : Byte utilizado
        para cadenas de texto
}

  CAFE_MaximoLargoIdentificadorSintactico       : Byte;
{
  CAFE_MaximoLargoIdentificadorSintactico       : Es el maximo
        tamano admisible para que se considere un identificador valido
}

  CAFE_ConjuntoByteExponenteSintactico          : CAFE_ConjuntoByte;
{
  Incluye dos posibles versiones UpCase DownCase de
  CAFE_ByteExponenteSintactico, para permitir el uso de minusculas
  en algunas sintaxis
}

  CAFE_BanderaCompatibleIdentificadorFinalLongInt,
{
  CAFE_BanderaCompatibleIdentificadorFinalLongInt       : Esta bandera
        advierte al programa que un identificador podra terminar en numero,
        lo que generalmente es cierto.
}

  CAFE_BanderaAsumeOperadorSintactico           : Boolean;
{
  CAFE_BanderaAsumeOperadorSintactico           : Bandera utilizada
        en el proceso de Nudillar...(disculpas por el invento),
        aqui seria
        CAFE_NudoSintactico.GenerarArbolSintacticoBasico
        TRUE Sirve para permitir funciones sin parentesis,
                cuando se requiera.
                por ejemplo PI --> PI()
        FALSE Sirve para inducir el operador parentesis
                por ejemplo PI -->  OperadorParentesis(Pi)
                Se utiliza
                CAFE_OperadorParentesisTraducidoOperadorBasico
        Se aplica cuando no se detecta OperadorBasico
}

  CAFE_ConjuntoEquivalenteByteBlancoSintactico,
{
  CAFE_ConjuntoEquivalenteByteBlancoSintactico  : Define un conjunto
        de caracteres a ignorar en el codigo, y considerar como
        equivalentes del blanco.
        NOTA: el char(13) podria aparecer como fin de comentario y tambien
        un equivalente blanco; no afecta si se eliminan comentarios primero.
}

  CAFE_ConjuntoByteSignoSintactico,
{
  CAFE_ConjuntoByteSignoSintactico              : Conjunto para
        identificar signos en los numeros.
}

  CAFE_PrimerByteIdentificadorSintactico,
{
  CAFE_PrimerByteIdentificadorSintactico        : Conjunto de los
        Bytes admisibles como primer byte de un identificador.
        Muchas veces tienen reglas especiales como no comenzar en numero
        arabigo.
}

  CAFE_MedioByteIdentificadorSintactico,
{
  CAFE_MedioByteIdentificadorSintactico         : Conjunto de los
        Bytes admisibles como bytes en el medio de un identificador.
}

  CAFE_UltimoByteIdentificadorSintactico        : CAFE_ConjuntoByte;
{
  CAFE_UltimoByteIdentificadorSintactico        : Conjunto de bytes
        admisibles al final de un identificador.  Por ejemplo,
        si se exige el dolar, etc...
}

CONST
  CAFE_2ErrorNudilladoGeneral                   : LongInt               = 1;
{
  CAFE_2ErrorNudilladoGeneral                   :
        Error en el proceso de nudillado sin especificar causa
}

  CAFE_2ErrorNudilladoSubOrden                  : LongInt               = 1;
{
  CAFE_2ErrorNudilladoSubOrden                  :
        Error al nudillar una determinada suborden
}

type
  CAFE_CharByteSintactico       = Packed CLASS ( CAFE_ClassCharByte )
{
  Clase evolucionada de CAFE_ClassCharByte, su objetivo es agregar
  caracteristicas de extraccion de parametros ante operadores binarios y
  unarios.  Por ejemplo en Carlos+2.5E-3; poder extraer el Carlos y el 2.5E-3
  sin confusion.
}

  Public
  // Actualizar siempre
CONSTRUCTOR Create
  (     Tamano          : LongInt                               ); override;
{
  Inicializa el CharByte para su buen funcionamiento,
  pero completamente vacio.
  Tamano es el nuevo TamanoVector. (no compatible FreeMem)
}

  // Actualizar siempre
CONSTRUCTOR Create
  ( CONST
        Msg             : ShortString;
        Tamano          : LongInt                               ); override;
{
  Inicializar el CharByte para su buen funcionamiento,
  con Msg como datos iniciales. No importa, utilizar Tamano "muy grande".
  Msg podria ser ''.
}

  // Actualizar siempre
CONSTRUCTOR Create
  (     Modelo          : CAFE_ClassCharByte                    ); override;
{
  Inicializa el CharByte, copiando completamente el dato
  CharByte de modelo, incluyendo su TamanoVector.
}

FUNCTION    ExtraccionParametroDerecho
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR PosicionFuente          : LongInt                       ) : Boolean;
{
  FUNCTION ExtraccionParametroDerecho
        El objetivo es extraer desde VectorFuente un parametro a la derecha.
        El resultado se devuelve en Self insertado
        al final, comenzando en Self[ Ocupado+1 ].
        Este parametro podria ser operador, identificador, numero o
        parentesis coherente.  El algoritmo resiste errores en el
        interior del operador, pues es una etapa inicial.
        Si el parametro es operador se EXIGE en esta etapa
        que el parentesis siga inmediatamente al nombre.
        Ejemplo: Carlos + Luis( 12 ), bien...
                 Carlos + Luis ( 12 ), error el parentesis debe seguir a Luis
        Se asume que el usuario posee otros algoritmos que corrigen
        este problema.
  VectorFuente          : Contiene la informacion sintactica a analizar.
  PosicionFuente        : De entrada debe apuntar a la posicion derecha
        o unica del operador (si mide un solo Byte), de salida
        intenta sealar el final del operador anexando espacios blanco
        si se puede.
  FUNCTION ExtraccionParametroDerecho   : TRUE indica exito en el proceso
        FALSE No se interpreta como error.  Esto porque algunos operadores
        podrian tener sobrecarga unaria o binaria.
}

FUNCTION    ExtraccionParametroIzquierdo
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR PosicionFuente          : LongInt                       ) : Boolean;
{
  FUNCTION ExtraccionParametroIzquierdo
        El objetivo es extraer desde VectorFuente un parametro a la izquierda
        El resultado se devuelve en Self insertado
        al final, comenzando en Self[ Ocupado+1 ].
        Este parametro podria ser operador, identificador, numero o
        parentesis coherente.  El algoritmo resiste errores en el
        interior del operador, pues es una etapa inicial.
        Si el parametro es operador se EXIGE en esta etapa
        que el parentesis siga inmediatamente al nombre.
        Ejemplo: Luis( 12 ) + Carlos, bien...
                 Luis ( 12 )+ Carlos, error el parentesis debe seguir a Luis
        Se asume que el usuario posee otros algoritmos que corrigen
        este problema.
  VectorFuente          : Contiene la informacion sintactica a analizar.
  PosicionFuente        : De entrada debe apuntar a la posicion izquierda
        o unica del operador (si mide un solo Byte), de salida
        intenta sealar el final del operador anexando espacios blanco
        si se puede.
  FUNCTION ExtraccionParametroIzquierdo : TRUE indica exito en el proceso
        FALSE No se interpreta como error.  Esto porque algunos operadores
        podrian tener sobrecarga unaria o binaria.
}

FUNCTION    AgregarOrdenBasicaParametro
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR PosicionFuente          : LongInt;
        DerechaIzquierda        : Boolean                       ) : Boolean;
{
  FUNCTION AgregarOrdenBasicaParametro
        Se asume que Self, es una orden basica bien escrita que termina
        con CAFE_ByteParentesisCerrarSintactico.
        Se intenta agregar un parametro a esta orden,
        tomandolo de VectorFuente.  Puede considerarse
        una version mejorada de FUNCTION ExtraccionParametroDerecho y
        FUNCTION ExtraccionParametroIzquierdo, que construye
        sobre un Operador basico en Self.
  VectorFuente                  : Contiene la informacion a analizar
        y extraer el parametro
  PosicionFuente                : de entrada da la posicion
        inicial (DerechaIzquierda=TRUE) o final (DerechaIzquierda=FALSE)
        del operador, de salida indica el final del parametro
        con blancos agregados si se puede.
  DerechaIzquierda              : TRUE solicita extraccion derecha
        y FALSE solicita extraccion izquierda de parametro.
  FUNCTION AgregarOrdenBasicaParametro  : devuelve TRUE para indicar
        exito y FALSE fracaso.  Esto no es un error necesariamente,
        pues algunos
        operadores podrian tener sobrecarga unaria y binaria, etc.
}

DESTRUCTOR  Destroy; override;
{
  DESTRUCTOR Destroy;
        Se produce la destruccion del CharByte.
}

                                  END;  { CLASS CAFE_CharByteSintactico }

  CAFE_ReferenciaInterpreteSintactico   = CLASS OF CAFE_InterpreteSintactico;
{
  CAFE_ReferenciaInterpreteSintactico           :
        Clase de referencia para CAFE_InterpreteSintactico
}

  CAFE_InterpreteSintactico     = Packed CLASS
{
  Clase basica interprete de nombres de identificadores.
  Asigna un valor al NombreIdentificador
}

  Public
    NombreIdentificador         : ShortString;
{
  NombreIdentificador           : Cadena de nombre de Identificador
}

    ValorInterpretado           : Variant;
{
  ValorInterpretado             : Si el Identificador tiene un valor
        sencillo de interpretacion, podria asignarse aqui
}

    BanderaVariant,
{
  BanderaVariant                : Si TRUE indica que es un Identificador
        cuya interpretacion es leer el Variant
}

    BanderaSimple               : Boolean;
{
  BanderaSimple                 : Previsto para futuras versiones.
        En la primera version de Ejes.EXE, todos los identificadores
        validos se consideran simples.
}

CONSTRUCTOR Create; virtual;
{
  Inicializa la clase, dando valores default
}

CONSTRUCTOR Create
  ( CONST Nombre                : ShortString;
          NuevoValor            : Variant                       ); virtual;
{
  Inicializa la clase, con asignaciones mas interesantes.  Permite
  dar un Nombre y un NuevoValor, para el interprete.
  Nombre                        : Nombre a asignar al identificador
  NuevoValor                    : Valor simple a asignar al identificador
}

DESTRUCTOR  Destroy; override;
{
  Destructor de clase
}

  Protected
    InterpreteReferencia        : CAFE_ReferenciaInterpreteSintactico;
{
  InterpreteReferencia          : Util en procesos de moldeo y copia
        de la clase, por dificultades surgidas.  Ademas otorga
        flexibilidad en la generacion de ancestros
}

                                  END;  { CLASS CAFE_InterpreteSintactico }

  CAFE_ReferenciaNudoSintactico = CLASS OF CAFE_NudoSintactico;
{
  CAFE_ReferenciaNudoSintactico         :
        Referencia de clase para el tipo CAFE_NudoSintactico
}

  CAFE_NudoSintactico           = Packed CLASS
{
  Clase cuyo objetivo principal es contener un arbol sintactico
  de instrucciones.  Que se ha traducido probablemente
  desde una cadena de texto o similar y convertido en Arbol Sintactico
  DescendienteHorizontal se referira principalmente a Parametros en
  el mismo nivel de profundidad
  DescendienteVertical ira desde un operador Padre a los parametros.
}

  Public
    IdentificadorElemento       : LongInt;
{
  IdentificadorElemento         : Al generar el arbol cada nodo contendra
        un numero unico de identificacion
}

    DatoElemento                : Variant;
{
  DatoElemento                  : Elemento del arbol, probablemente
        uno de tres tipos : Identificador, Operador o numero real o entero.
}

    DescendienteHorizontal,
{
  DescendienteHorizontal        : Para generar secuencias de parametros
        a un mismo nivel de profundidad gramatical
}

    DescendienteVertical        : CAFE_NudoSintactico;
{
  DescendienteVertical          : Para apuntar desde un Operador Basico
        hasta el primer parametro de dicho operador
}

    DatoInterpretado            : CAFE_InterpreteSintactico;
{
  DatoInterpretado              : Campo que ayuda a interpretar el
        DatoElemento, de forma que el Arbol "sepa" que hacer.
}

CONSTRUCTOR Create; virtual;
{
  Constructor de clase basico, genera un identificador unico interno
}

CONSTRUCTOR Create
  (     Ide                     : LongInt                       ); virtual;
{
  Constructor de clase basico, permite obligar el identificador Ide.
        Esto es util, por ejemplo, en procesos de copia
}

CONSTRUCTOR Create
  (     Ide                     : LongInt;
        NuevoDato               : Variant                       ); virtual;
{
  Constructor de clase basico, agrega el numero identificador, y
        ademas NuevoDato se asigna a DatoElemento
}

CONSTRUCTOR Create
  (     Modelo                  : CAFE_NudoSintactico           ); virtual;
{
  Constructor de clase, que utiliza un modelo para adquirir datos,
        incluyendo el numero identificador.
}

PROCEDURE   GenerarArbolSintacticoBasico
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR Ubicacion               : LongInt;
        HorizontalDescendiente  : Boolean                               );
{
  PROCEDURE GenerarArbolSintacticoBasico
        A partir de VectorFuente que contiene un OperadorBasico bien
        construido, se genera un arbol sintactico comenzando.
  VectorFuente                  : Contiene el OperadorBasico
        en formato de operador bien resuelto
  Ubicacion                     : INPUT  --> identificador de posicion
        del elemento del nodo, a partir del cual se genera el arbol,
        en Self[ Ubicacion ].DescendienteVertical o en
        Self[ Ubicacion ].DescendienteHorizontal segun
        (HorizontalDescendiente), si es 0
        Se genera en Self mismo.
                                  OUTPUT --> devuelve el identificador
        elemento de la cabeza del nodo generado (podria ser Self).
        En el caso de Self (INPUT 0) el NumeroIdentificador
        va a ser diferente antes
        y despues del llamado exitoso a PROCEDURE
  HorizontalDescendiente        :
        Si TRUE ubica en Self[ Ubicacion ].DescendienteVertical
        Si FALSE ubica en Self[ Ubicacion ].DescendienteHorizontal
  NOTA : Errores se reportan en CAFE_IntentoInfructuosoSintactico
        con probable CAFE_MensajeIntentoInfructuosoSintactico,
        se recomienda revisar esta bandera a la salida
  NOTA : Puede utilizar la bandera CAFE_BanderaAsumeOperadorSintactico
        para tratar identificadores o numeros solos.
}

PROCEDURE   VaciarInterior;
{
  PROCEDURE VaciarInterior
        Para borron y cuenta nueva.  Algunos arboles pueden ser muy grandes.
        A los interpretes se les asigna simplemente el valor NIL.
        Esto deberia ser suficiente si la clase existe como unica.
        Se conserva el valor de NumeroIdentificador.
}

DESTRUCTOR  Destroy; override;
{
  Destructor de clase
}

  Strict Private
PROCEDURE   AgregarRegistroUnidadSintacticaSiguiente
  (     Ubicacion               : LongInt;
        PunteroDato             : CAFE_NudoSintactico;
        BanderaReferenciaIdentificador          : Boolean               );

  Strict Private
PROCEDURE   AgregarRegistroUnidadSintacticaDescendiente
  (     Ubicacion               : LongInt;
        PunteroDato             : CAFE_NudoSintactico;
        BanderaReferenciaIdentificador          : Boolean               );

  Strict Private
PROCEDURE   AuxiliarGenerarArbolSintacticoBasico
  (     VectorFuente            : CAFE_ClassCharByte;
        PosicionFuente          : LongInt;
    VAR Ubicacion               : LongInt;
        HorizontalDescendiente  : Boolean                               );

  Protected
    MoldeGenerar                : CAFE_ReferenciaNudoSintactico;
{
  MoldeGenerar                  : Para ayudar en la generacion de
        los descendientes.  Funcion similar a ClassType
}

  Strict Private
FUNCTION    ReadItems
  (     Ide                     : LongInt       ) : CAFE_NudoSintactico;

  Public
  Property
    Items[ Ide : LongInt ]      : CAFE_NudoSintactico
                                  Read ReadItems; Default;
{
  Self[ Item ]                  : devuelve el nodo que concuerde
        en su NumeroIdentificador. Unicamente lectura.
        De no encontrar genera NIL sin error.
}

                                  END;  { CLASS CAFE_NudoSintactico }

FUNCTION    CAFE_BuscarParejaPareadaCharByteSintactico
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR PosicionActual          : LongInt;
        ByteParentesisAbrir, ByteParentesisCerrar       : Byte;
        Direccion               : Boolean = TRUE                ) : Boolean;
{
  FUNCTION CAFE_BuscarParejaPareadaCharByteSintactico
        Su objetivo es desplazarse en VectorFuente entre un
        abrir y cerrar parentesis, tomando en cuenta anidamiento de los
        mismos.
  VectorFuente                  : Contiene la informacion a analizar
  PosicionActual                :
        INPUT  --> Direccion TRUE  apunta a un ByteParentesisAbrir
                   Direccion FALSE apunta a un ByteParentesisCerrar
        OUTPUT --> Direccion TRUE  apunda a un ByteParentesisCerrar
                   Direccion FALSE apunta a un ByteParentesisAbrir
        NOTA : INPUT se asume cierto, asi que usted podria engaar
                a la computadora, aunque no se recomienda
        OUTPUT cualquiera si FUNCTION devuelve FALSE
  ByteParentesisAbrir           : Byte utilizado como apertura de parentesis
  ByteParentesisCerrar          : Byte utilizado para cerrar parentesis
  Direccion                     : TRUE indica hacia la derecha    -->
                                  FALSE indica hacia la izquierda <--
  FUNCTION CAFE_BuscarParejaPareadaCharByteSintactico
        Devuelve TRUE si es un exito y FALSE si fracaso
        no se considera error, a este nivel;  aunque probablemente lo sea.
}

FUNCTION    CAFE_TotalApuntadoresNudo
  (     MyNudo                  : CAFE_NudoSintactico           ) : LongInt;
{
  FUNCTION CAFE_TotalApuntadoresNudo
        Cuenta el total de nodos en el arbol, a partir de MyNudo
  MyNudo                        : Cabeza o punto de partida del conteo
}

FUNCTION    CAFE_TipoVariante
  ( CONST
       MyVariante               : Variant               ) : SizeInt; inline;
{
  FUNCTION CAFE_TipoVariante
        Devuelve el tipo de MyVariante
        Cuidado, vararray no se identifica
  MyVariante                    : Dato a determinar el tipo
}

//var

implementation
  // Para numerar CAFE_NudoSintactico
VAR
  ConteoIdentificadorNudo               : LongInt               = 0;

CONST
  IncrementoConteoIdentificadorNudo     = 1;

  {$IFDEF       SILENCIAR       }
  {$WARNINGS    OFF             }
  {$ENDIF                       }
CONSTRUCTOR CAFE_CharByteSintactico.Create
  (     Tamano          : LongInt                               );
BEGIN  { CONSTRUCTOR CAFE_CharByteSintactico.Create }
  Inherited;
  ModeloInterior        := CAFE_ClassCharByte;
END;   { CONSTRUCTOR CAFE_CharByteSintactico.Create }
  {$IFDEF       SILENCIAR       }
  {$WARNINGS    ON              }
  {$ENDIF                       }

  {$IFDEF       SILENCIAR       }
  {$WARNINGS    OFF             }
  {$ENDIF                       }
CONSTRUCTOR CAFE_CharByteSintactico.Create
  ( CONST
        Msg             : ShortString;
        Tamano          : LongInt                               );
BEGIN  { CONSTRUCTOR CAFE_CharByteSintactico.Create }
  Inherited;
  ModeloInterior        := CAFE_CharByteSintactico;
END;   { CONSTRUCTOR CAFE_CharByteSintactico.Create }
  {$IFDEF       SILENCIAR       }
  {$WARNINGS    ON              }
  {$ENDIF                       }

  {$IFDEF       SILENCIAR       }
  {$WARNINGS    OFF             }
  {$ENDIF                       }
CONSTRUCTOR CAFE_CharByteSintactico.Create
  (     Modelo          : CAFE_ClassCharByte                    );
BEGIN  { CONSTRUCTOR CAFE_CharByteSintactico.Create }
  Inherited;
  ModeloInterior        := CAFE_CharByteSintactico;
END;   { CONSTRUCTOR CAFE_CharByteSintactico.Create }
  {$IFDEF       SILENCIAR       }
  {$WARNINGS    ON              }
  {$ENDIF                       }

FUNCTION    CAFE_CharByteSintactico.ExtraccionParametroDerecho
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR PosicionFuente          : LongInt                       ) : Boolean;
{
  PosicionFuente despues del operador... o sea, inicio del operando o blanco
}
VAR
  ColocarFinal,
  NuevoPivote,
  PosicionPivote,
  PosicionMedioByte             : LongInt;
  PrimerByte,
  MedioByte                     : Byte;
  DecimalHabil,
  ExponenteHabil                : Boolean;

LABEL
  BuscarNumero,
  SalidaVerdadera,
  SalidaFalsa;

BEGIN  { FUNCTION CAFE_CharByteSintactico.ExtraccionParametroDerecho }
  IF ( PosicionFuente <= 0 ) OR ( PosicionFuente > VectorFuente.Ocupado )
  THEN GOTO SalidaFalsa;
  PosicionPivote                := PosicionFuente-1;
  NuevoPivote                   := 0;
  ColocarFinal                  := NuevoPivote;
  REPEAT
    IF NOT( VectorFuente.BuscarSiguienteByte( PosicionPivote,
        CAFE_ByteBlancoSintactico, TRUE, FALSE ) ) THEN GOTO SalidaFalsa;
    IF NuevoPivote = 0 THEN NuevoPivote := PosicionPivote;
    PrimerByte                  := VectorFuente[ PosicionPivote ];
  UNTIL NOT( PrimerByte IN CAFE_ConjuntoByteSignoSintactico );
  IF PrimerByte IN
        ( CAFE_PrimerByteIdentificadorSintactico+
                [ CAFE_ByteParentesisAbrirSintactico ] )
  THEN BEGIN
    IF PrimerByte IN CAFE_PrimerByteIdentificadorSintactico THEN BEGIN
      PosicionMedioByte           := PosicionPivote;
      IF PosicionMedioByte = VectorFuente.Ocupado THEN BEGIN
        ColocarFinal              := PosicionMedioByte;
        GOTO SalidaVerdadera;
      END;  { IF PosicionMedioByte = VectorFuente^.Ocupado }
      REPEAT
        Inc( PosicionMedioByte );
        MedioByte                 := VectorFuente[ PosicionMedioByte ];
      UNTIL ( PosicionMedioByte = VectorFuente.Ocupado ) OR
          NOT( MedioByte IN CAFE_MedioByteIdentificadorSintactico );
      IF PosicionMedioByte = VectorFuente.Ocupado THEN BEGIN
        IF NOT( MedioByte IN CAFE_UltimoByteIdentificadorSintactico ) AND
           ( MedioByte IN CAFE_MedioByteIdentificadorSintactico )
        THEN GOTO SalidaFalsa;
      END;  { IF PosicionMedioByte = VectorFuente^.Ocupado }
      IF NOT( MedioByte IN CAFE_UltimoByteIdentificadorSintactico ) THEN BEGIN
        Dec( PosicionMedioByte );
        IF ( PosicionMedioByte-PosicionPivote ) > 0 THEN BEGIN
          MedioByte               := VectorFuente[ PosicionMedioByte ];
          IF NOT( MedioByte IN CAFE_UltimoByteIdentificadorSintactico )
          THEN GOTO SalidaFalsa;
        END;  { IF ( PosicionMedioByte-PosicionPivote ) }
      END;  { IF NOT( MedioByte IN CAFE_UltimoByteIdentificadorSintactico }
      ColocarFinal                := PosicionMedioByte;
      PosicionPivote              := ColocarFinal+1;
      IF PosicionPivote < VectorFuente.Ocupado
          THEN PrimerByte         := VectorFuente[ PosicionPivote ]
          ELSE PrimerByte         := CAFE_ByteBlancoSintactico;
     END;  { IF PrimerByte IN ... }
    IF PrimerByte = CAFE_ByteParentesisAbrirSintactico THEN BEGIN
      IF CAFE_BuscarParejaPareadaCharByteSintactico
          ( VectorFuente, PosicionPivote, CAFE_ByteParentesisAbrirSintactico,
                  CAFE_ByteParentesisCerrarSintactico, TRUE )
      THEN BEGIN
        ColocarFinal              := PosicionPivote;
        GOTO SalidaVerdadera;
      END ELSE BEGIN  { IF BuscarParejaPareadaCharByteSintactico (...) ELSE }
        GOTO SalidaFalsa;
      END;            { IF BuscarParejaPareadaCharByteSintactico (...) ELSE }
    END;  { IF PrimerByte = ByteParentesisAbrirSintactico }
    ColocarFinal                  := PosicionPivote-1;
    GOTO SalidaVerdadera;
  END;  { IF PrimerByte = ... + ByteParentesis... }
  IF PrimerByte IN CAFE_ConjuntoByteNumeroArabigo THEN BEGIN
    DecimalHabil                := TRUE;
    ExponenteHabil              := TRUE;
    PosicionMedioByte           := PosicionPivote;
BuscarNumero :
    IF PosicionMedioByte = VectorFuente.Ocupado THEN BEGIN
      ColocarFinal              := PosicionMedioByte;
      GOTO SalidaVerdadera;
    END;  { IF PosicionMedioByte = VectorFuente^.Ocupado }
    REPEAT
      Inc( PosicionMedioByte );
      MedioByte                 := VectorFuente[ PosicionMedioByte ];
    UNTIL ( PosicionMedioByte = VectorFuente.Ocupado ) OR
        NOT( MedioByte IN CAFE_ConjuntoByteNumeroArabigo );
    IF PosicionMedioByte = VectorFuente.Ocupado THEN BEGIN
      IF NOT( MedioByte IN CAFE_ConjuntoByteNumeroArabigo )
      THEN Dec( PosicionMedioByte );
      ColocarFinal              := PosicionMedioByte;
      GOTO SalidaVerdadera;
    END;  { IF PosicionMedioByte = VectorFuente^.Ocupado }
    IF DecimalHabil THEN BEGIN
      IF MedioByte = CAFE_ByteDecimalSintactico THEN BEGIN
        DecimalHabil            := FALSE;
        Inc( PosicionMedioByte );
        MedioByte               := VectorFuente[ PosicionMedioByte ];
        IF MedioByte IN CAFE_ConjuntoByteNumeroArabigo
        THEN GOTO BuscarNumero
        ELSE GOTO SalidaFalsa;
      END;  { IF MedioByte IN CAFE_ByteDecimalSintactico }
    END;  { IF DecimalHabil }
    IF ExponenteHabil  THEN BEGIN
      IF MedioByte IN CAFE_ConjuntoByteExponenteSintactico THEN BEGIN
        DecimalHabil            := FALSE;
        ExponenteHabil          := FALSE;
        Inc( PosicionMedioByte );
        MedioByte               := VectorFuente[ PosicionMedioByte ];
        IF MedioByte IN CAFE_ConjuntoByteSignoNumerico THEN BEGIN
          IF PosicionMedioByte = VectorFuente.Ocupado THEN GOTO SalidaFalsa;
          Inc( PosicionMedioByte );
          MedioByte             := VectorFuente[ PosicionMedioByte ];
        END;  { IF MedioByte IN CAFE_ConjuntoByteSignoNumerico }
        IF MedioByte IN CAFE_ConjuntoByteNumeroArabigo
        THEN GOTO BuscarNumero
        ELSE GOTO SalidaFalsa;
      END;  { IF MedioByte = CAFE_ByteExponenteSintactico }
    END;  { IF ExponenteHabil }
    ColocarFinal                := PosicionMedioByte-1;
    GOTO SalidaVerdadera;
  END;  { IF PrimerByte IN CAFE_ConjuntoByteNumeroArabigo }
  GOTO SalidaFalsa;
SalidaVerdadera :
  InsertarExtraccionCharByte( Ocupado+1,
        VectorFuente, NuevoPivote, ColocarFinal-NuevoPivote+1 );
  PosicionFuente                := ColocarFinal;
  IF VectorFuente.BuscarSiguienteByte
        ( ColocarFinal, CAFE_ByteBlancoSintactico, TRUE, FALSE )
  THEN PosicionFuente           := ColocarFinal-1
  ELSE PosicionFuente           := VectorFuente.Ocupado;
  ExtraccionParametroDerecho    := TRUE;
  Exit;
SalidaFalsa :
  ExtraccionParametroDerecho    := FALSE;
END;   { FUNCTION CAFE_CharByteSintactico.ExtraccionParametroDerecho }

FUNCTION    CAFE_CharByteSintactico.ExtraccionParametroIzquierdo
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR PosicionFuente          : LongInt                       ) : Boolean;
VAR
  ConjuntoConfundible           : CAFE_ConjuntoByte;
  NuevoPivote,
  PosicionPivote,
  ColocarFinal                  : LongInt;
  UltimoByte                    : Byte;
  PosibleIdentificador          : Boolean;

LABEL
  SalidaVerdadera,
  SalidaFinVerdad,
  SalidaFalsa,
  MedioIdentificador,
  FinalIdentificador;

    { ANIDADO }
  FUNCTION AnidadoPosibleNumero
    (     ValidoDecimal, ValidoE                : Boolean;
      VAR ValidoIdentificador                   : Boolean;
      VAR PosicionMovible                       : LongInt       ) : Boolean;
  VAR
    PivoteExtra,
    PosicionPivote              : LongInt;
    BytePivoteExtra,
    BytePivote                  : Byte;
    BanderaEspecial             : Boolean;

  LABEL
    SalidaFalsa,
    SalidaVerdadera,
    SalidaIdentificador;

  BEGIN  { FUNCTION AnidadoPosibleNumero }
    WITH VectorFuente DO BEGIN
      IF PosicionMovible = 0 THEN GOTO SalidaFalsa;
      PosicionPivote            := PosicionMovible+1;
      REPEAT
        Dec( PosicionPivote );
        BytePivote              := Byte( MemoriaChar[ PosicionPivote ] );
      UNTIL ( PosicionPivote = 1 ) OR
        NOT( BytePivote IN CAFE_ConjuntoByteNumeroArabigo );
      IF BytePivote IN CAFE_ConjuntoByteNumeroArabigo
      THEN GOTO SalidaVerdadera;
      IF PosicionPivote = PosicionMovible THEN GOTO SalidaIdentificador;
      IF ValidoDecimal THEN BEGIN
        IF BytePivote = CAFE_ByteDecimalSintactico THEN BEGIN
          Dec( PosicionPivote );
          ValidoIdentificador   := FALSE;
          IF AnidadoPosibleNumero( FALSE, FALSE,
                        ValidoIdentificador, PosicionPivote )
          THEN GOTO SalidaVerdadera
          ELSE GOTO SalidaFalsa;
        END;  { IF BytePivote = CAFE_ByteSeparadorSintactico }
      END;  { IF ValidoSeparador }
      IF ValidoE THEN BEGIN
        PivoteExtra             := PosicionPivote;
        BytePivoteExtra         := BytePivote;
        IF BytePivote IN CAFE_ConjuntoByteSignoNumerico THEN BEGIN
          IF PosicionPivote = 1 THEN BEGIN
            GOTO SalidaVerdadera;
          END;  { IF PosicionPivote = 1 }
          BanderaEspecial       := TRUE;
          Dec( PivoteExtra );
          BytePivote            := Byte( MemoriaChar[ PivoteExtra ] );
        END ELSE BEGIN  { IF BytePivote IN ConjuntoByteSignoNumerico ELSE }
          BanderaEspecial       := FALSE;
        END;            { IF BytePivote IN ConjuntoByteSignoNumerico ELSE }
        IF BytePivote IN CAFE_ConjuntoByteExponenteSintactico THEN BEGIN
          Dec( PivoteExtra );
          IF AnidadoPosibleNumero( TRUE, FALSE,
                        ValidoIdentificador, PivoteExtra ) THEN BEGIN
            PosicionPivote      := PivoteExtra;
            GOTO SalidaVerdadera;
          END ELSE BEGIN  { IF AnidadoPosibleNumero( ... ) ELSE }
            IF BanderaEspecial THEN BEGIN
              Inc( PosicionPivote );
              GOTO SalidaVerdadera;
            END;  { IF BanderaEspecial }
            IF ValidoIdentificador
                        THEN GOTO SalidaIdentificador
                        ELSE GOTO SalidaFalsa;
          END;            { IF AnidadoPosibleNumero( ... ) ELSE }
        END;  {IF BytePivote IN CAFE_ConjuntoByteExponenteSintactico }
        BytePivote              := BytePivoteExtra;
      END;  { IF ValidoE }
      IF BytePivote IN ConjuntoConfundible THEN BEGIN
        IF ValidoIdentificador
                THEN GOTO SalidaIdentificador
                ELSE GOTO SalidaFalsa;
      END;  { IF BytePivote = ConjuntoConfundible }
      PosicionPivote            := PosicionPivote+1;
    END;  { WITH VectorFuente }
SalidaVerdadera :
    ValidoIdentificador         := FALSE;
    PosicionMovible             := PosicionPivote;
    AnidadoPosibleNumero        := TRUE;
    Exit;
SalidaIdentificador :
    IF ValidoIdentificador THEN PosicionMovible := PosicionPivote;
SalidaFalsa :
    AnidadoPosibleNumero        := FALSE;
  END;   { FUNCTION AnidadoPosibleNumero }
    { ANIDADO }

BEGIN  { FUNCTION CAFE_CharByteSintactico.ExtraccionParametroIzquierdo }
  IF ( PosicionFuente <= 0 ) OR ( PosicionFuente > VectorFuente.Ocupado )
  THEN GOTO SalidaFalsa;
  ConjuntoConfundible           := CAFE_PrimerByteIdentificadorSintactico+
        CAFE_MedioByteIdentificadorSintactico+
        CAFE_UltimoByteIdentificadorSintactico;
  PosicionPivote                := PosicionFuente+1;
  IF NOT( VectorFuente.BuscarSiguienteByte
        ( PosicionPivote, CAFE_ByteBlancoSintactico, FALSE, FALSE ) )
  THEN GOTO SalidaFalsa;
  UltimoByte                    := VectorFuente[ PosicionPivote ];
  ColocarFinal                  := PosicionPivote;
  NuevoPivote                   := ColocarFinal;
  PosibleIdentificador          := TRUE;
  IF UltimoByte = CAFE_ByteParentesisCerrarSintactico THEN BEGIN
    IF CAFE_BuscarParejaPareadaCharByteSintactico
        ( VectorFuente, PosicionPivote, CAFE_ByteParentesisAbrirSintactico,
          CAFE_ByteParentesisCerrarSintactico, FALSE ) THEN BEGIN
      IF PosicionPivote = 1 THEN GOTO SalidaFinVerdad;
      NuevoPivote               := PosicionPivote;
      Dec( PosicionPivote );
      UltimoByte                := VectorFuente[ PosicionPivote ];
    END ELSE BEGIN  { IF CAFE_BuscarParejaPareadoCharByteSintactico... ELSE }
      GOTO SalidaFalsa;
    END;            { IF CAFE_BuscarParejaPareadoCharByteSintactico... ELSE }
  END ELSE BEGIN  { IF UltimoByte = CAFE_ParentesisCerrarSintactico ELSE }
    IF UltimoByte IN CAFE_ConjuntoByteNumeroArabigo THEN BEGIN
      PosibleIdentificador      :=
                CAFE_BanderaCompatibleIdentificadorFinalLongInt;
      IF AnidadoPosibleNumero
         ( TRUE, TRUE, PosibleIdentificador, PosicionPivote ) THEN BEGIN
        GOTO SalidaFinVerdad;
      END;  { IF AnidadoPosibleNumero(...) }
      Inc( PosicionPivote );
      IF PosibleIdentificador THEN GOTO MedioIdentificador
                              ELSE GOTO SalidaFalsa;
    END;  { IF UltimoByte IN CAFE_ConjuntoByteNumeroArabigo }
  END;            { IF UltimoByte = CAFE_ParentesisCerrarSintactico ELSE }
  IF NOT( UltimoByte IN CAFE_UltimoByteIdentificadorSintactico )
  THEN GOTO FinalIdentificador;
  IF PosicionPivote = 1 THEN GOTO FinalIdentificador;
  Dec( PosicionPivote );
MedioIdentificador :
  REPEAT
    UltimoByte                  := VectorFuente[ PosicionPivote ];
    Dec( PosicionPivote );
    IF PosicionPivote = 0 THEN BEGIN
      Inc( PosicionPivote );
      GOTO FinalIdentificador;
    END;  { IF PosicionPivote = 0 }
  UNTIL NOT( UltimoByte IN CAFE_MedioByteIdentificadorSintactico );
  Inc( PosicionPivote );
FinalIdentificador :
  IF UltimoByte IN CAFE_PrimerByteIdentificadorSintactico
  THEN GOTO SalidaVerdadera;
  IF PosicionPivote < NuevoPivote THEN BEGIN
    Inc( PosicionPivote );
    UltimoByte                  := VectorFuente[ PosicionPivote ];
    IF UltimoByte IN CAFE_PrimerByteIdentificadorSintactico
    THEN GOTO SalidaVerdadera;
  END;  { IF PosicionPivote < ColocarFinal }
  IF NuevoPivote <> ColocarFinal THEN BEGIN
    PosicionPivote              := NuevoPivote;
    GOTO SalidaFinVerdad;
  END;  { IF NuevoPivote <> ColocarFinal }
  GOTO SalidaFalsa;
SalidaVerdadera :
  IF PosicionPivote > 1 THEN BEGIN
    Dec( PosicionPivote );
    UltimoByte                  := VectorFuente[ PosicionPivote ];
    IF UltimoByte IN CAFE_MedioByteIdentificadorSintactico
    THEN GOTO SalidaFalsa;
    Inc( PosicionPivote );
  END;  { IF PosicionPivote > 1 }
SalidaFinVerdad :
  InsertarExtraccionCharByte( Ocupado+1, VectorFuente,
                PosicionPivote, ColocarFinal-PosicionPivote+1 );
  PosicionFuente                := PosicionPivote;
  IF VectorFuente.BuscarSiguienteByte( PosicionPivote,
        CAFE_ByteBlancoSintactico, FALSE, FALSE )
  THEN BEGIN
    IF VectorFuente[ PosicionPivote ] IN
                ConjuntoConfundible THEN BEGIN
      PosicionFuente            := PosicionPivote+2;
    END ELSE BEGIN  { IF ... IN ConjuntoConfundible ELSE }
      PosicionFuente            := PosicionPivote+1;
    END;            { IF ... IN ConjuntoConfundible ELSE }
  END ELSE BEGIN  { IF ...BuscarSiguienteByte... ELSE }
    PosicionFuente              := 1;
  END;            { IF ...BuscarSiguienteByte... ELSE }
  ExtraccionParametroIzquierdo  := TRUE;
  Exit;
SalidaFalsa :
  ExtraccionParametroIzquierdo  := FALSE;
END;   { FUNCTION CAFE_CharByteSintactico.ExtraccionParametroIzquierdo }

FUNCTION    CAFE_CharByteSintactico.AgregarOrdenBasicaParametro
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR PosicionFuente          : LongInt;
        DerechaIzquierda        : Boolean                       ) : Boolean;
VAR
  PosicionSeguridad1,
  PosicionSeguridad2            : LongInt;
  BanderaSobreEscribirCerrar,
  BanderaSeguridadCerrar,
  BanderaExtra                  : Boolean;

LABEL
  SalidaFalsa;

BEGIN  { FUNCTION CAFE_CharByteSintactico.AgregarOrdenBasicaParametro }
  PosicionSeguridad1            := PosicionFuente;
  BanderaExtra                  := FALSE;
  PosicionSeguridad2            := Ocupado;
  BanderaSobreEscribirCerrar    := FALSE;
  BanderaSeguridadCerrar        := FALSE;
  IF Ocupado <= 2 THEN GOTO SalidaFalsa;
  IF Self[ Ocupado ] <> CAFE_ByteParentesisCerrarSintactico
  THEN GOTO SalidaFalsa;
  BanderaSeguridadCerrar        := TRUE;
  IF Self[ Ocupado-1 ] = CAFE_ByteParentesisAbrirSintactico
  THEN Dec( Ocupado )
  ELSE BEGIN   { IF Self[ Ocupado-1 ] = ... ELSE }
    Self[ Ocupado ]             := CAFE_ByteSeparadorSintactico;
    BanderaSobreEscribirCerrar  := TRUE;
  END;         { IF Self[ Ocupado-1 ] = ... ELSE }
  IF DerechaIzquierda THEN BEGIN
    IF ExtraccionParametroDerecho( VectorFuente, PosicionFuente )
    THEN BanderaExtra           := TRUE;
  END ELSE BEGIN  { IF DerechaIzquierda ELSE }
    IF ExtraccionParametroIzquierdo( VectorFuente, PosicionFuente )
    THEN BanderaExtra           := TRUE;
  END;            { IF DerechaIzquierda ELSE }
  IF BanderaExtra THEN BEGIN
    IF Ocupado < TamanoVector THEN BEGIN
      Inc( Ocupado );
      Self[ Ocupado ]           := CAFE_ByteParentesisCerrarSintactico;
    END ELSE BEGIN  { IF Ocupado < TamanoVector ELSE }
      GOTO SalidaFalsa;
    END;            { IF Ocupado < TamanoVector ELSE }
  END ELSE BEGIN  { IF BanderaExtra ELSE }
    GOTO SalidaFalsa;
  END;            { IF BanderaExtra ELSE }
  AgregarOrdenBasicaParametro   := TRUE;
  Exit;
SalidaFalsa :
  PosicionFuente                := PosicionSeguridad1;
  Ocupado                       := PosicionSeguridad2;
  IF BanderaSeguridadCerrar THEN BEGIN
    IF NOT( BanderaSobreEscribirCerrar ) THEN Inc( Ocupado );
    Self[ Ocupado ]             := CAFE_ByteParentesisCerrarSintactico;
  END;  { IF BanderaSeguridadCerrar }
  AgregarOrdenBasicaParametro   := FALSE;
END;   { FUNCTION CAFE_CharByteSintactico.AgregarOrdenBasicaParametro }

DESTRUCTOR  CAFE_CharByteSintactico.Destroy;
BEGIN  { CONSTRUCTOR CAFE_CharByteSintactico.Destroy }
  Inherited
END;   { CONSTRUCTOR CAFE_CharByteSintactico.Destroy }

CONSTRUCTOR CAFE_NudoSintactico.Create;
BEGIN  { CONSTRUCTOR CAFE_NudoSintactico.Create }
  Inc( ConteoIdentificadorNudo, IncrementoConteoIdentificadorNudo );
  IdentificadorElemento         := ConteoIdentificadorNudo;
  DatoElemento                  := 0;
  MoldeGenerar                  := CAFE_NudoSintactico;
  DescendienteHorizontal        := NIL;
  DescendienteVertical          := NIL;
  DatoInterpretado              := NIL;
END;   { CONSTRUCTOR CAFE_NudoSintactico.Create }

CONSTRUCTOR CAFE_NudoSintactico.Create
  (     Ide                     : LongInt                               );
BEGIN  { CONSTRUCTOR CAFE_NudoSintactico.Create }
  IdentificadorElemento         := Ide;
  DatoElemento                  := Null;
  MoldeGenerar                  := CAFE_NudoSintactico;
  DescendienteHorizontal        := NIL;
  DescendienteVertical          := NIL;
  DatoInterpretado              := NIL;
END;   { CONSTRUCTOR CAFE_NudoSintactico.Create }

CONSTRUCTOR CAFE_NudoSintactico.Create
  (     Ide                     : LongInt;
        NuevoDato               : Variant                               );
BEGIN  { CONSTRUCTOR CAFE_NudoSintactico.Create }
  IdentificadorElemento         := Ide;
  DatoElemento                  := NuevoDato;
  MoldeGenerar                  := CAFE_NudoSintactico;
  DescendienteHorizontal        := NIL;
  DescendienteVertical          := NIL;
  DatoInterpretado              := NIL;
END;   { CONSTRUCTOR CAFE_NudoSintactico.Create }

CONSTRUCTOR CAFE_NudoSintactico.Create
  (     Modelo                  : CAFE_NudoSintactico                   );
BEGIN  { CONSTRUCTOR CAFE_NudoSintactico.Create }
  IdentificadorElemento         := Modelo.IdentificadorElemento;
  DatoElemento                  := Modelo.DatoElemento;
  IF Modelo.DescendienteHorizontal = NIL
  THEN DescendienteHorizontal   := NIL
  ELSE BEGIN  { IF Modelo.DescendienteVertical = NIL ELSE }
    MoldeGenerar                := Modelo.DescendienteHorizontal.MoldeGenerar;
    DescendienteHorizontal      :=
                MoldeGenerar.Create( Modelo.DescendienteHorizontal );
                // Probable fallo por nivel de herencia
  END;        { IF Modelo.DescendienteVertical = NIL ELSE }
  IF Modelo.DescendienteVertical = NIL
  THEN DescendienteVertical     := NIL
  ELSE BEGIN  { IF Modelo.DescendienteVertical = NIL ELSE }
    MoldeGenerar                := Modelo.DescendienteVertical.MoldeGenerar;
    DescendienteVertical        :=
                MoldeGenerar.Create( Modelo.DescendienteVertical );
                // Probable fallo por nivel de herencia
  END;        { IF Modelo.DescendienteVertical = NIL ELSE }
  MoldeGenerar                  := CAFE_NudoSintactico;
  DatoInterpretado              := Modelo.DatoInterpretado;
END;   { CONSTRUCTOR CAFE_NudoSintactico.Create }

PROCEDURE   CAFE_NudoSintactico.GenerarArbolSintacticoBasico
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR Ubicacion               : LongInt;
        HorizontalDescendiente  : Boolean                               );
VAR
  Cadenita                      : ShortString;
  PosicionFuente                : Byte;

LABEL
  SalidaInfructuosa;

BEGIN  { PROCEDURE CAFE_NudoSintactico.GenerarArbolSintacticoBasico }
  WITH VectorFuente DO BEGIN
    PosicionFuente              := VerificarFormatoOrdenBasica
        ( CAFE_ByteBlancoSintactico, CAFE_ByteParentesisAbrirSintactico,
          CAFE_ByteParentesisCerrarSintactico,
          CAFE_ByteSeparadorSintactico, TRUE );
    IF PosicionFuente = 0 THEN BEGIN
      IF Ocupado = 0 THEN Exit;
      IF CAFE_BanderaAsumeOperadorSintactico THEN BEGIN
        IF TamanoVector < ( Ocupado+2 ) THEN GOTO SalidaInfructuosa;
        Inc( Ocupado );
        VectorFuente[ Ocupado ] := CAFE_ByteParentesisAbrirSintactico;
        PosicionFuente          := Ocupado;
        Inc( Ocupado );
        VectorFuente[ Ocupado ] := CAFE_ByteParentesisCerrarSintactico;
      END ELSE BEGIN  { IF BanderaAsumeOperadorSintactico ELSE }
        PosicionFuente          :=
                Length( CAFE_OperadorParentesisTraducidoOperadorBasico )-1;
        Cadenita                :=
                Copy( CAFE_OperadorParentesisTraducidoOperadorBasico, 1,
                        PosicionFuente )+
                ExtraerString+')';
        Ocupado                 := 0;
        InsertarString( Cadenita );
      END;            { IF BanderaAsumeOperadorSintactico ELSE }
    END;  { IF PosicionFuente = 0 }
    IF VerificarIdentificadorBasicoInsertado
        ( Cadenita, 1, PosicionFuente-1,
          CAFE_PrimerByteIdentificadorSintactico,
          CAFE_MedioByteIdentificadorSintactico,
          CAFE_UltimoByteIdentificadorSintactico )
    THEN AuxiliarGenerarArbolSintacticoBasico( VectorFuente,
                PosicionFuente, Ubicacion, HorizontalDescendiente )
    ELSE GOTO SalidaInfructuosa;
  END;  { WITH VectorFuente }
  Exit;
SalidaInfructuosa :
  IF CAFE_PosicionInfructuosoSintactico <> 0 THEN Exit;
  CAFE_IntentoInfructuosoSintactico             := TRUE;
  CAFE_MensajeInfructuosoSintactico             := 'Error Sintactico';
  CAFE_PosicionInfructuosoSintactico            :=
                                CAFE_2ErrorNudilladoGeneral;
END;   { PROCEDURE CAFE_NudoSintactico.GenerarArbolSintacticoBasico }

PROCEDURE   CAFE_NudoSintactico.AgregarRegistroUnidadSintacticaSiguiente
  (     Ubicacion               : LongInt;
        PunteroDato             : CAFE_NudoSintactico;
        BanderaReferenciaIdentificador          : Boolean       );
VAR
  UbicadoInterno                : CAFE_NudoSintactico;

LABEL
  SalidaError;

BEGIN  { PROCEDURE ...AgregarRegistroUnidadSintacticaSiguiente }
  IF PunteroDato = NIL THEN GOTO SalidaError;
  IF PunteroDato.DescendienteHorizontal <> NIL THEN GOTO SalidaError;
  IF Ubicacion = 0
  THEN UbicadoInterno           := Self
  ELSE UbicadoInterno           := Self[ Ubicacion ];
  IF UbicadoInterno = NIL THEN GOTO SalidaError;
  IF UbicadoInterno <> NIL THEN BEGIN
    PunteroDato.DescendienteHorizontal          :=
                        UbicadoInterno.DescendienteHorizontal;
    UbicadoInterno.DescendienteHorizontal       := PunteroDato;
  END;  { IF UbicadoInterno <> NIL }
  IF BanderaReferenciaIdentificador THEN BEGIN
    Inc( ConteoIdentificadorNudo, IncrementoConteoIdentificadorNudo );
    PunteroDato.IdentificadorElemento           := ConteoIdentificadorNudo;
  END;  { IF BanderaReferenciaIdentificador }
  Exit;
SalidaError :
  RAISE CAFE_Exception.Create( 'Error acceso a elemento invlido en'+
        ' CAFE_NudoSintactico.AgregarRegistroUnidadSintacticaSiguiente' );
END;   { PROCEDURE ...AgregarRegistroUnidadSintacticaSiguiente }

PROCEDURE   CAFE_NudoSintactico.AgregarRegistroUnidadSintacticaDescendiente
  (     Ubicacion               : LongInt;
        PunteroDato             : CAFE_NudoSintactico;
        BanderaReferenciaIdentificador          : Boolean               );
VAR
  UbicadoInterno                : CAFE_NudoSintactico;

LABEL
  SalidaError;

BEGIN  { PROCEDURE ...AgregarRegistroUnidadSintacticaDescendiente }
  IF PunteroDato = NIL THEN GOTO SalidaError;
  IF PunteroDato.DescendienteVertical <> NIL THEN GOTO SalidaError;
  IF Ubicacion = 0
  THEN UbicadoInterno           := Self
  ELSE UbicadoInterno           := Self[ Ubicacion ];
  IF UbicadoInterno = NIL THEN GOTO SalidaError;
  IF UbicadoInterno <> NIL THEN BEGIN
    PunteroDato.DescendienteVertical            :=
                        UbicadoInterno.DescendienteVertical;
    UbicadoInterno.DescendienteVertical         := PunteroDato;
  END;  { IF UbicadoInterno <> NIL }
  IF BanderaReferenciaIdentificador THEN BEGIN
    Inc( ConteoIdentificadorNudo, IncrementoConteoIdentificadorNudo );
    PunteroDato.IdentificadorElemento           := ConteoIdentificadorNudo;
  END;  { IF BanderaReferenciaIdentificador }
  Exit;
SalidaError :
  RAISE CAFE_Exception.Create( 'Error acceso a elemento invlido en'+
        ' CAFE_NudoSintactico.AgregarRegistroUnidadSintacticaDescendiente' );
END;   { PROCEDURE ...AgregarRegistroUnidadSintacticaDescendiente }

  {$IFDEF       SILENCIAR       }
  {$WARNINGS    OFF             }
  {$ENDIF                       }
PROCEDURE   CAFE_NudoSintactico.AuxiliarGenerarArbolSintacticoBasico
  (     VectorFuente            : CAFE_ClassCharByte;
        PosicionFuente          : LongInt;
    VAR Ubicacion               : LongInt;
        HorizontalDescendiente  : Boolean                               );
VAR
  OtraCadenaAnsi,
  CadenaAnsi                    : AnsiString;
  OtraCadena,
  CadenaAuxiliar                : ShortString;
  PunteroSintactico             : CAFE_NudoSintactico;
  NuevoSintactico               : CAFE_ClassCharByte;
  RealPivote                    : CAFE_Real;
  UbicacionPivote,
  EnteroPivote                  : LongInt;
  PosicionPivote                : Byte;
  BanderaPrimero                : Boolean;

LABEL
  SalidaInfructuosa,
  FinalLabel;

BEGIN  { PROCEDURE CAFE_NudoSintactico.AuxiliarGenerarArbolSintacticoBasico }
  NuevoSintactico               := NIL;
  PunteroSintactico             := NIL;
  WITH VectorFuente DO BEGIN
    OtraCadena                  := ExtraerString( 1, PosicionFuente )+
                                Chr( CAFE_ByteParentesisCerrarSintactico );
    CadenaAnsi                  := Concat( OtraCadena );
    IF Ubicacion = 0 THEN BEGIN
      VaciarInterior;
      DatoElemento              := CadenaAnsi;
      Inc( ConteoIdentificadorNudo, IncrementoConteoIdentificadorNudo );
      IdentificadorElemento     := ConteoIdentificadorNudo;
      PunteroSintactico         := Self;
    END ELSE BEGIN  { IF Ubicacion = 0 ELSE }
      PunteroSintactico         := MoldeGenerar.Create;
      PunteroSintactico.DatoElemento            := CadenaAnsi;
      IF HorizontalDescendiente THEN BEGIN
        AgregarRegistroUnidadSintacticaSiguiente
          ( Ubicacion, PunteroSintactico, FALSE );
      END ELSE BEGIN  { IF HorizontalDescendiente ELSE }
        AgregarRegistroUnidadSintacticaDescendiente
          ( Ubicacion, PunteroSintactico, FALSE );
      END;            { IF HorizontalDescendiente ELSE }
    END;            { IF Ubicacion = 0 ELSE }                                      { Variable en Implementation }
    Ubicacion                   := PunteroSintactico.IdentificadorElemento;
    UbicacionPivote             := PunteroSintactico.IdentificadorElemento;
    EliminarDatosCharByte( 1, PosicionFuente );
    Dec( Ocupado );
    IF Ocupado = 0 THEN Exit;
    PosicionFuente              := 0;
    NuevoSintactico             := CAFE_ClassCharByte.Create( VectorFuente );
  END;  { WITH VectorFuente }
  WITH NuevoSintactico DO BEGIN
    PunteroSintactico           := NIL;
    Ocupado                     := 0;
    BanderaPrimero              := TRUE;
    WHILE ExtraccionFuenteSeparador
        ( VectorFuente, PosicionFuente, CAFE_ByteSeparadorSintactico,
          CAFE_ByteParentesisAbrirSintactico,
          CAFE_ByteParentesisCerrarSintactico,
          TRUE, TRUE ) DO BEGIN
      PosicionPivote            := VerificarFormatoOrdenBasica
        ( CAFE_ByteBlancoSintactico, CAFE_ByteParentesisAbrirSintactico,
          CAFE_ByteParentesisCerrarSintactico,
          CAFE_ByteSeparadorSintactico, TRUE );
      IF PosicionPivote <> 0 THEN BEGIN
        IF VerificarIdentificadorBasicoInsertado
                ( OtraCadena, 1, PosicionPivote-1,
                  CAFE_PrimerByteIdentificadorSintactico,
                  CAFE_MedioByteIdentificadorSintactico,
                  CAFE_UltimoByteIdentificadorSintactico )
        THEN
          AuxiliarGenerarArbolSintacticoBasico
            ( NuevoSintactico, PosicionPivote, UbicacionPivote,
              NOT( BanderaPrimero ) )
        ELSE GOTO SalidaInfructuosa;
        IF CAFE_IntentoInfructuosoSintactico THEN GOTO SalidaInfructuosa;
      END ELSE BEGIN  { IF PosicionPivote <> 0 ELSE }
        IF Ocupado > CAFE_MaximoLargoIdentificadorSintactico
        THEN GOTO SalidaInfructuosa;
        IF ( Ocupado = 0 ) AND BanderaPrimero AND
                ( PosicionFuente > VectorFuente.Ocupado )
        THEN GOTO FinalLabel;
        PunteroSintactico       := MoldeGenerar.Create;
        WITH PunteroSintactico DO BEGIN
          IF NOT( VerificarIdentificadorBasicoInsertado
                ( CadenaAuxiliar, 1, Ocupado,
                  CAFE_PrimerByteIdentificadorSintactico,
                  CAFE_MedioByteIdentificadorSintactico,
                  CAFE_UltimoByteIdentificadorSintactico ) ) THEN BEGIN
            IF Ocupado <> 0 THEN BEGIN
              IF VerificarNumeroLongInt( EnteroPivote ) THEN BEGIN
                DatoElemento            := EnteroPivote;
              END ELSE BEGIN  { IF VerificarNumeroLongInt( ... ) ELSE }
                IF VerificarNumeroReal( RealPivote ) THEN BEGIN
                  DatoElemento          := RealPivote;
                END ELSE BEGIN  { IF VerificarNumeroSingle( ... ) ELSE }
                  GOTO SalidaInfructuosa;
                END;            { IF VerificarNumeroSingle( ... ) ELSE }
              END;            { IF VerificarNumeroLongInt( ... ) ELSE }
            END;  { IF Ocupado <> 0 }
          END ELSE BEGIN  { IF NOT( VerificarIdentificadorBasico... ) }
            OtraCadenaAnsi              := Concat( CadenaAuxiliar );
            DatoElemento                := OtraCadenaAnsi;
          END;            { IF NOT( VerificarIdentificadorBasico... ) }
        END;  { WITH PunteroSintactico^ }
        IF BanderaPrimero THEN BEGIN
          AgregarRegistroUnidadSintacticaDescendiente
          ( UbicacionPivote, PunteroSintactico, FALSE );
        END ELSE BEGIN  { IF BanderaPrimero ELSE }
          AgregarRegistroUnidadSintacticaSiguiente
          ( UbicacionPivote, PunteroSintactico, FALSE );
        END;            { IF BanderaPrimero ELSE }
        UbicacionPivote         := PunteroSintactico.IdentificadorElemento;
      END;            { IF PosicionPivote <> 0 ELSE }
      BanderaPrimero            := FALSE;
      PunteroSintactico         := NIL;
    END;  { WHILE }
  END;  { WITH NuevoSintactico }
  GOTO FinalLabel;
SalidaInfructuosa :
  IF ( PunteroSintactico <> NIL  ) AND
     ( PunteroSintactico <> Self ) THEN FreeAndNil( PunteroSintactico );
  IF CAFE_IntentoInfructuosoSintactico THEN GOTO FinalLabel;
  CAFE_IntentoInfructuosoSintactico             := TRUE;
  CAFE_MensajeInfructuosoSintactico             := OtraCadena;
  CAFE_PosicionInfructuosoSintactico            :=
                                CAFE_2ErrorNudilladoSubOrden;
FinalLabel :
  IF NuevoSintactico <> NIL THEN FreeAndNil( NuevoSintactico )
END;   { PROCEDURE CAFE_NudoSintactico.AuxiliarGenerarArbolSintacticoBasico }
  {$IFDEF       SILENCIAR       }
  {$WARNINGS    ON              }
  {$ENDIF                       }

FUNCTION    CAFE_NudoSintactico.ReadItems
  (     Ide                     : LongInt       ) : CAFE_NudoSintactico;
VAR
  PivoteResultado               : CAFE_NudoSintactico;

BEGIN  { FUNCTION CAFE_NudoSintactico.ReadItems }
  PivoteResultado               := NIL;
  IF Ide = IdentificadorElemento THEN BEGIN
    PivoteResultado             := Self;
  END ELSE BEGIN  { IF Ide = IdentificadorElemento ELSE }
    IF DescendienteVertical <> NIL
    THEN PivoteResultado        := DescendienteVertical[ Ide ];
    IF ( PivoteResultado = NIL ) AND ( DescendienteHorizontal <> NIL )
    THEN PivoteResultado        := DescendienteHorizontal[ Ide ];
  END;            { IF Ide = IdentificadorElemento ELSE }
  ReadItems                     := PivoteResultado;
END;   { FUNCTION CAFE_NudoSintactico.ReadItems }

PROCEDURE   CAFE_NudoSintactico.VaciarInterior;
{ virtual }
BEGIN  { CAFE_NudoSintactico.VaciarInterior }
  DatoInterpretado              := NIL;
  // CUIDADO, potencial fuente de problemas
  // si no hay un adecuado conteo de clases
  FreeAndNil( DescendienteVertical );
  FreeAndNil( DescendienteHorizontal );
  DatoElemento                  := Null;
END;   { CAFE_NudoSintactico.VaciarInterior }

DESTRUCTOR  CAFE_NudoSintactico.Destroy;
BEGIN  { DESTRUCTOR CAFE_NudoSintactico.Destroy }
  VaciarInterior;
END;   { DESTRUCTOR CAFE_NudoSintactico.Destroy }

CONSTRUCTOR CAFE_InterpreteSintactico.Create;
BEGIN  { CONSTRUCTOR CAFE_InterpreteSintactico.Create }
  NombreIdentificador           := '';
  ValorInterpretado             := Null;
  BanderaVariant                := TRUE;
  BanderaSimple                 := TRUE;
  InterpreteReferencia          := CAFE_InterpreteSintactico;
END;   { CONSTRUCTOR CAFE_InterpreteSintactico.Create }

CONSTRUCTOR CAFE_InterpreteSintactico.Create
  ( CONST Nombre                : ShortString;
          NuevoValor            : Variant                               );
BEGIN  { CONSTRUCTOR CAFE_InterpreteSintactico.Create }
  NombreIdentificador           := Nombre;
  ValorInterpretado             := NuevoValor;
  BanderaVariant                := TRUE;
  BanderaSimple                 := TRUE;
  InterpreteReferencia          := CAFE_InterpreteSintactico;
END;   { CONSTRUCTOR CAFE_InterpreteSintactico.Create }

DESTRUCTOR  CAFE_InterpreteSintactico.Destroy;
BEGIN  { DESTRUCTOR CAFE_InterpreteSintactico.Destroy }
  NombreIdentificador           := '';
  ValorInterpretado             := Null;
  BanderaVariant                := TRUE;
  BanderaSimple                 := TRUE;
  InterpreteReferencia          := CAFE_InterpreteSintactico;
END;   { DESTRUCTOR CAFE_InterpreteSintactico.Destroy }

FUNCTION    CAFE_BuscarParejaPareadaCharByteSintactico
  (     VectorFuente            : CAFE_ClassCharByte;
    VAR PosicionActual          : LongInt;
        ByteParentesisAbrir, ByteParentesisCerrar       : Byte;
        Direccion               : Boolean                       ) : Boolean;
VAR
  PosicionBusquedaAbrir,
  PosicionBusquedaCerrar,
  CuentaIzquierda               : LongInt;
  ParentesisPivote              : Byte;
  BanderaBusquedaAbrir,
  BanderaBusquedaCerrar,
  BanderaUltimoAbrir            : Boolean;

LABEL
  SalidaFalsa;

BEGIN  { FUNCTION ...BuscarParejaPareadaCharByteSintactico }
  IF NOT( Direccion ) THEN BEGIN
    ParentesisPivote            := ByteParentesisAbrir;
    ByteParentesisAbrir         := ByteParentesisCerrar;
    ByteParentesisCerrar        := ParentesisPivote;
  END;  { IF NOT( Direccion ) }
  CuentaIzquierda               := 0;
  BanderaBusquedaCerrar         := TRUE;
  BanderaBusquedaAbrir          := TRUE;
  PosicionBusquedaCerrar        := PosicionActual;
  PosicionBusquedaAbrir         := PosicionActual;
  BanderaUltimoAbrir            := FALSE;
  REPEAT
    IF BanderaBusquedaCerrar THEN BEGIN
      IF VectorFuente.BuscarSiguienteByte( PosicionBusquedaCerrar,
                ByteParentesisCerrar, Direccion, TRUE ) THEN BEGIN
        BanderaBusquedaCerrar   := BanderaUltimoAbrir OR ( Direccion XOR
                        ( PosicionBusquedaCerrar > PosicionBusquedaAbrir ) );
        IF BanderaBusquedaCerrar THEN BEGIN
          Dec( CuentaIzquierda );
        END ELSE BEGIN  { IF BanderaBusquedaCerrar ELSE }
          BanderaBusquedaAbrir  := NOT( BanderaUltimoAbrir );
          IF BanderaBusquedaAbrir THEN Inc( CuentaIzquierda );
        END;            { IF BanderaBusquedaCerrar ELSE }
      END ELSE BEGIN  { BuscarSiguienteByte( ... ) ELSE }
        GOTO SalidaFalsa;
      END;            { BuscarSiguienteByte( ... ) ELSE }
    END;  { IF BanderaBusquedaCerrar }
    IF BanderaBusquedaAbrir THEN BEGIN
      IF VectorFuente.BuscarSiguienteByte( PosicionBusquedaAbrir,
                ByteParentesisAbrir, Direccion, TRUE ) THEN BEGIN
        BanderaBusquedaAbrir    := Direccion XOR
                ( PosicionBusquedaAbrir > PosicionBusquedaCerrar );
        IF BanderaBusquedaAbrir THEN BEGIN
          Inc( CuentaIzquierda );
        END ELSE BEGIN  { IF BanderaBusquedaAbrir ELSE }
          BanderaBusquedaCerrar := TRUE;
          Dec( CuentaIzquierda );
        END;            { IF BanderaBusquedaAbrir ELSE }
      END ELSE BEGIN  { IF BuscarSiguienteByte( ... ) ELSE }
        Dec( CuentaIzquierda );
        BanderaBusquedaAbrir    := FALSE;
        BanderaUltimoAbrir      := TRUE;
        BanderaBusquedaCerrar   := TRUE;
      END;            { IF BuscarSiguienteByte( ... ) ELSE }
    END;  { IF BanderaBusquedaAbrir }
  UNTIL ( CuentaIzquierda = 0 );
  PosicionActual                := PosicionBusquedaCerrar;
  CAFE_BuscarParejaPareadaCharByteSintactico            := TRUE;
  Exit;
SalidaFalsa :
  CAFE_BuscarParejaPareadaCharByteSintactico            := FALSE;
END;   { FUNCTION ...BuscarParejaPareadaCharByteSintactico }

FUNCTION    CAFE_TotalApuntadoresNudo
  (     MyNudo                  : CAFE_NudoSintactico           ) : LongInt;
BEGIN  { FUNCTION CAFE_TotalApuntadoresNudo }
  IF MyNudo = NIL THEN BEGIN
    Exit( 0 );
  END ELSE BEGIN  { IF MyNudo = NIL ELSE }
    CAFE_TotalApuntadoresNudo           := 1+
        CAFE_TotalApuntadoresNudo( MyNudo.DescendienteVertical   )+
        CAFE_TotalApuntadoresNudo( MyNudo.DescendienteHorizontal );
  END;            { IF MyNudo = NIL ELSE }
END;   { FUNCTION CAFE_TotalApuntadoresNudo }

FUNCTION    CAFE_TipoVariante
  ( CONST
       MyVariante               : Variant               ) : SizeInt; inline;
BEGIN  { FUNCTION CAFE_TipoVariante }
  Exit( PSizeInt( @MyVariante )^ AND VarTypeMask );
END;   { FUNCTION CAFE_TipoVariante }

CONST
  CharBlancoPascal              = ' ';
  ByteBlancoPascal              = Ord( CharBlancoPascal );
  CharParentesisAbrirPascal     = '(';
  ByteParentesisAbrirPascal     = Ord( CharParentesisAbrirPascal );
  CharParentesisCerrarPascal    = ')';
  ByteParentesisCerrarPascal    = Ord( CharParentesisCerrarPascal );
  CharSeparadorPascal           = ',';
  ByteSeparadorPascal           = Ord( CharSeparadorPascal );
  CharDelimitadorStringPascal   = '''';
  ByteDelimitadorStringPascal   = Ord( CharDelimitadorStringPascal );

CONST
  ConjuntoPrimerByteIdentificadorPascal         : CAFE_ConjuntoByte  =
        [ Ord( 'A' )..Ord( 'Z' ), Ord( 'a' )..Ord( 'z' ), Ord( '_' ) ];
  ConjuntoSiguienteByteIdentificadorPascal      : CAFE_ConjuntoByte  =
        [ Ord( 'A' )..Ord( 'Z' ), Ord( 'a' )..Ord( 'z' ),
                        Ord( '0' )..Ord( '9' )  , Ord( '_' )    ];
  ConjuntoEquivalenteByteBlancoPascal           : CAFE_ConjuntoByte  =
        [ 0       , 7..10              , 13       , Ord( '_' ), 255        ];

CONST
  CharDecimalPascal                             = '.';
  ByteDecimalPascal                             = Ord( CharDecimalPascal );
  CharExponentePascal                           = 'E';
  ByteExponentePascal                           = Ord( CharExponentePascal );
  CharSeparadorOrdenPascal                      = ';';
  ByteSeparadorOrdenPascal                      =
                                Ord( CharSeparadorOrdenPascal );

initialization
  CAFE_ByteBlancoSintactico          := ByteBlancoPascal;
  CAFE_ByteParentesisAbrirSintactico := ByteParentesisAbrirPascal;
  CAFE_ByteParentesisCerrarSintactico                        :=
                                ByteParentesisCerrarPascal;
  CAFE_ByteSeparadorSintactico       := ByteSeparadorPascal;
  CAFE_MaximoLargoIdentificadorSintactico                    := 80;
  CAFE_PrimerByteIdentificadorSintactico                     :=
                                ConjuntoPrimerByteIdentificadorPascal;
  CAFE_MedioByteIdentificadorSintactico                      :=
                                ConjuntoSiguienteByteIdentificadorPascal;
  CAFE_UltimoByteIdentificadorSintactico                     :=
                                ConjuntoSiguienteByteIdentificadorPascal;
  CAFE_BanderaAsumeOperadorSintactico                        := FALSE;
                        { Permite operadores sin parametros ni parentesis }
  CAFE_ByteDecimalSintactico         := ByteDecimalPascal;
  CAFE_ByteExponenteSintactico       := ByteExponentePascal;
  CAFE_ConjuntoByteExponenteSintactico          :=
        [ Ord( LowerCase( CharExponentePascal ) ) ]+
        [ Ord( UpCase   ( CharExponentePascal ) ) ];
  CAFE_ConjuntoByteSignoSintactico   := CAFE_ConjuntoByteSignoNumerico;
  CAFE_BanderaCompatibleIdentificadorFinalLongInt            :=
    CAFE_ConjuntoByteNumeroArabigo <= CAFE_UltimoByteIdentificadorSintactico;
  CAFE_ByteSeparadorOrdenSintactico     := ByteSeparadorOrdenPascal;
  Include( CAFE_PrimerByteIdentificadorSintactico, CAFE_ByteIgnoradoLibre );
  Include( CAFE_PrimerByteIdentificadorSintactico, CAFE_ByteHojaCalculoFija );
  Include( CAFE_MedioByteIdentificadorSintactico , CAFE_ByteHojaCalculoFija );
  CAFE_ByteDelimitadorStringSintactico  := ByteDelimitadorStringPascal;
  CAFE_ConjuntoEquivalenteByteBlancoSintactico  := ConjuntoEquivalenteByteBlancoPascal;
finalization
end.


